﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Data;
using Infragistics.Controls.Interactions;
using Infragistics.Controls.Grids.Primitives;
using Infragistics.Windows;
using System.Collections;
using System.Globalization;
using System.Collections.ObjectModel;
using Infragistics.Controls.Grids;

namespace XamGridDateColumn
{
    /// <summary>
    /// Interaction logic for AdvancedDateConfiguration.xaml
    /// </summary>
    public partial class DateConfig : XamDialogWindow
    {

        #region "Variables"

        DataTable _dtAdvDateConfig;
        ObservableCollection<Person> _colPerson;
       
        #endregion

        public bool IsGenericUser
        {
            get { return (bool)this.GetValue(IsGenericUserProperty); }
            set { this.SetValue(IsGenericUserProperty, value); }
        }

        public static readonly DependencyProperty IsGenericUserProperty =
        DependencyProperty.Register(
            "IsGenericUser",
            typeof(bool),
            typeof(DateConfig), new FrameworkPropertyMetadata(true,
new PropertyChangedCallback(OnIsGenericUserChanged)));

        private static void OnIsGenericUserChanged(DependencyObject source, DependencyPropertyChangedEventArgs e)
        {            
            //Button control = source as Button;            
            //control.IsEnabled = false;            
        }
        #region "Constructor"

        public DateConfig()
        {
            InitializeComponent();
        }

        #endregion

        #region "Event Handlers"      

        private void XamDialogWindow_Loaded(object sender, RoutedEventArgs e)
        {
            AdvDateConfigs.ItemsSource = _dtAdvDateConfig.DefaultView;
            //AdvDateConfigs.ItemsSource = _colPerson;
        }       

        private void btnUpdate_Click(object sender, RoutedEventArgs e)
        {        
            IsGenericUser = false;
            //AdvDateConfigs.Columns[0]
            //MessageBox.Show("Updated!");
            //((Infragistics.Controls.Grids.TextColumn)(AdvDateConfigs.Columns[1])).IsReadOnly = false           
        }
       
        #endregion

        private void AdvDateConfigs_CellExitingEditMode(object sender, Infragistics.Controls.Grids.ExitEditingCellEventArgs e)
        {
            if (e.Cell.Column.Key == "StartofPeriod")
            {
                if ((e.Editor as DatePicker).SelectedDate > Convert.ToDateTime(e.Cell.Row.Cells["EndofPeriod"].Value))
                {
                    e.Cancel = true;
                    Dispatcher.BeginInvoke(new Action(() =>
                    {
                        (e.Editor as DatePicker).SelectedDate = Convert.ToDateTime(e.Cell.Value);
                        (e.Editor as DatePicker).DisplayDate = Convert.ToDateTime(e.Cell.Value);
                        e.Cell.IsActive = true;
                        e.Cell.IsSelected = true;
                    }));

                }
            }
        }

        #region "Properties"
        public DataTable AdvDateConfig
        {
            get { return _dtAdvDateConfig; }
            set { _dtAdvDateConfig = value; }
        }

        public ObservableCollection<Person> Person
        {
            get { return _colPerson; }
            set { _colPerson = value; }
        }

        #endregion
                       
    }

    public static class AdvConfigSettings
    {
        public static int year;
    }

    public class MyConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return AdvConfigSettings.year + (int)value;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
